/*
Bedienung:
MemBrain starten.
Das Netz ffnen.
Den Lesson Editor ffnen.
Die Training Lesson laden (Lesson 1).
"Number of Lessons" oben auf 2 setzen.
"Currently Edited / Training Lesson" auf 2 setzen.
Jetzt die Datei mit den "Validierungsdaten" laden.
Das Kstchen "Set Manually" anklicken.
"Currently Edited / Training Lesson" wieder auf 1 setzen.

Am Schlu sollte das so aussehen:
"Number of Lessons" = 2.
"Currently Edited / Training Lesson" = 1.
"Net Error Lesson" = 2.

Jetzt noch den richtigen Teacher einstellen.

Falls noch nicht geschehen:
Alle Inputneuronen markieren und dann auf "Extras > Normalization Wizard".
Alle Outputneuronen markieren und nochmal auf "Extras > Normalization Wizard".

Das Netz abspeichern.

Jetzt das Script mit "Scripting > Execute Script" starten.

Das Script giebt immer wenn der Net Error noch tiefer fllt (Das Netz besser trainiert ist) eine Zeile im "Trace Windows" aus.

Etwa so:
Der minimale Net Error von: 0.0107511		wurde bei einer Trainingszeit von: 9 Sekunden erreicht.

Erscheint lngere Zeit keine neue Zeile mehr, hat man etwa die Zeit, die das Netz zum trainieren braucht um das beste Ergebnis zu bringen.
(Das Script sollte man natrlich fter laufen lassen und dann die Durchschnittswerte nehmen).

Den ermittelten "minimalen Net Error" kann man jetzt dem Teacher als Abbruchkriterium des Trainings geben.

Das Script wird gestopt, wenn man den Teacher anhlt (Teach > Stop Teacher (Auto).
*/

void main()
{
   StopThink();
   StopTeaching();
   
   uint32 Seconds = 1;
   double Net_Error = -1.0;
   double Min_Net_Error = -1.0;

   ResetNet();
   RandomizeNet();
   ResetThinkSteps();
   ShowPatternErrorViewer(true);
   
   StartTeaching();
   
   while (IsTeaching())
   {
      StartTimer(1000);

      while (!IsTimerExpired())
      {
         Net_Error = GetNetError();

         if ((Min_Net_Error < 0) || (Net_Error < Min_Net_Error))
         {
            Min_Net_Error = Net_Error;

            if (Min_Net_Error > -1.0)
            {
               Trace("Der minimale Net Error von: " + Min_Net_Error + "\t\t\twurde bei einer Trainingszeit von: " + Seconds + " Sekunden erreicht.\n");
            }
         }

         else
         {
            Sleep(10);
         }
      }

      Seconds++;
      PatternErrorViewerFitYScale();
      }
}